#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_widget.eo.h"
}

#include "elm_interface_atspi_accessible.eo.hh"
#include "elm_interface_atspi_component.eo.hh"

struct elm_interface_atspi_widget
      : elm_interface_atspi_accessible,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_component>::template type< ::elm_interface_atspi_widget>,
      efl::eo::detail::extension_inheritance<efl::eo::base>::template type< ::elm_interface_atspi_widget>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_widget(Eo* eo)
      : elm_interface_atspi_accessible(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_widget(std::nullptr_t)
      : elm_interface_atspi_accessible(nullptr)
   {}

   elm_interface_atspi_widget(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : elm_interface_atspi_widget(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_widget(elm_interface_atspi_widget const& other)
      : elm_interface_atspi_accessible(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_widget() {}

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_WIDGET_MIXIN);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(ELM_INTERFACE_ATSPI_WIDGET_MIXIN, _p._eo_raw, eo_constructor());
   }

};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_widget >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_widget >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_widget>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_widget >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_widget, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::elm_interface_atspi_widget >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_widget, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_widget>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_widget() const
      {
         return ::elm_interface_atspi_widget(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_widget>)
{
   return (ELM_INTERFACE_ATSPI_WIDGET_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_HH

