#ifndef EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_ACTION_HH
#define EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_ACTION_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_interface_atspi_widget_action.eo.h"
}

#include "elm_interface_atspi_action.eo.hh"

struct elm_interface_atspi_widget_action
      : elm_interface_atspi_action
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_interface_atspi_widget_action(Eo* eo)
      : elm_interface_atspi_action(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_interface_atspi_widget_action(std::nullptr_t)
      : elm_interface_atspi_action(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_interface_atspi_widget_action(elm_interface_atspi_widget_action const& other)
      : elm_interface_atspi_action(eo_ref(other._eo_ptr()))
   {}

   ~elm_interface_atspi_widget_action() {}

   /// @param actions NULL-terminated array of Elm_Actions
   ///
   const Elm_Atspi_Action * elm_actions_get() const
   {
      const Elm_Atspi_Action * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ELM_INTERFACE_ATSPI_WIDGET_ACTION_MIXIN);
   }

private:
};
template <typename T>
const Elm_Atspi_Action * _elm_interface_atspi_widget_action_elm_actions_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->elm_actions_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_widget_action >
{
   template <typename T>
   struct type
   {
      virtual const Elm_Atspi_Action * elm_actions_get()
      {
         const Elm_Atspi_Action * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_widget_action >
{
   static const int value = 1;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_interface_atspi_widget_action>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_widget_action_elm_actions_get_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_widget_action_elm_actions_get);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::elm_interface_atspi_widget_action >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_interface_atspi_widget_action, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_interface_atspi_widget_action>
{
   template <typename U>
   struct type
   {
      operator ::elm_interface_atspi_widget_action() const
      {
         return ::elm_interface_atspi_widget_action(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      const Elm_Atspi_Action * elm_actions_get()
      {
         const Elm_Atspi_Action * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_widget_action>)
{
   return (ELM_INTERFACE_ATSPI_WIDGET_ACTION_MIXIN);
}

} } }
#endif // EFL_GENERATED_ELM_INTERFACE_ATSPI_WIDGET_ACTION_HH

