#ifndef EFL_GENERATED_ELM_ATSPI_APP_OBJECT_HH
#define EFL_GENERATED_ELM_ATSPI_APP_OBJECT_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_atspi_app_object.eo.h"
}

#include "elm_interface_atspi_accessible.eo.hh"

struct elm_atspi_app_object
      : efl::eo::base,
      efl::eo::detail::extension_inheritance<elm_interface_atspi_accessible>::template type< ::elm_atspi_app_object>

{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_atspi_app_object(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_atspi_app_object(std::nullptr_t)
      : efl::eo::base(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_atspi_app_object(elm_atspi_app_object const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~elm_atspi_app_object() {}

   static Eo_Class const* _eo_class()
   {
      return(ELM_ATSPI_APP_OBJECT_CLASS);
   }

private:
};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_atspi_app_object >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::elm_atspi_app_object >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::elm_atspi_app_object>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< ::elm_atspi_app_object >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::elm_atspi_app_object, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::elm_atspi_app_object>
{
   template <typename U>
   struct type
   {
      operator ::elm_atspi_app_object() const
      {
         return ::elm_atspi_app_object(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::elm_atspi_app_object>)
{
   return (ELM_ATSPI_APP_OBJECT_CLASS);
}

} } }
#endif // EFL_GENERATED_ELM_ATSPI_APP_OBJECT_HH

